#include <stdio.h>
#include <string.h>
#ifdef WIN32
    #include <winsock2.h>
    #include  <ws2tcpip.h>
#else
    #include <sys/socket.h>
    #include <netinet/in.h>
    #include <arpa/inet.h>
#endif
#include <sys/types.h>
#include <fcntl.h>
#include "../sqlite/sqlite3.h"
#include "Chunk.h"
#include "chink.h"
#include "uSQLsec.h"
#include "gLog.h"
#include "uSQLct.h"
#include "uSQLst.h"

int execDB(sqlite3 *db,int strt,int fnsh){
char **res,query[100];
int rows,cols,pos=0,tst,i;

	sprintf(query,"Select Idx,Query from uSQL_P where Idx between %i and %i",strt,fnsh);
	tst=sqlite3_get_table(db,query,&res,&rows,&cols,NULL);
	if((rows<1) || (cols!=2) || (tst!=SQLITE_OK))goto fail;
    for(i=1;i<=rows;i++){
        pos=atoi(res[i*cols]);
        tst=sqlite3_exec(db,res[(i*cols)+1],NULL,NULL,NULL);
        if(tst!=SQLITE_OK)goto fail;
    }

    ++pos;  // will be returning fnsh+1 if all executed OK

fail:
	sqlite3_free_table(res);
	return pos;
}


void RemoveClient(uSQLst *st,uSQLct *Client){

	struct clientLL *itr=st->Clients;

	while(itr){
		// TODO or perhaps if it aint broke ;-)
		if(itr->curr==Client){
			if(!itr->prev && !itr->next){
				uSQLctDestroy(itr->curr);
				st->Clients=NULL;
				free(itr);
				return;
			}
			else if(!itr->prev && itr->next){
				st->Clients=itr->next;
				st->Clients->prev=NULL;
				uSQLctDestroy(itr->curr);
				free(itr);
				return;
			}
			else if(itr->prev && !itr->next){
				itr->prev->next=NULL;
				uSQLctDestroy(itr->curr);
				free(itr);
				return;
			}
			else if(itr->prev && itr->next){
				itr->prev->next=itr->next;
				itr->next->prev=itr->prev;
				uSQLctDestroy(itr->curr);
				free(itr);
				return;
			}
		}
		itr=itr->next;
	}
	return;
}

void MakeNewClient(uSQLst *st,int socknum){
struct sockaddr_in name;
int addsize=sizeof(struct sockaddr_in);
struct clientLL *nl=NULL;
int i,foo;
char logt[100];
int netsec;

    // Before doing anything check that the connection has arrived
    // from a valid network, and just silently drop it if not valid.
    if(getpeername(socknum,(struct sockaddr*)&name,&addsize))goto fail;

    if(!(netsec=uSQLsecGetNetLevel(st->sec, inet_ntoa(name.sin_addr))))goto fail;

	//foo=WSAGetLastError();
	// Make a cursor to the end of the list
	nl=st->Clients;i=0;
	while(nl){i++;nl=nl->next;}
	if(i>=st->maxclients){
		st->Log("uSQLiteServer","Too many clients\n",0);
		
    // Service unavailable first informs HTTP conections, raw techfell should ignore
    // this and pickup the :Err line
    // This HHTP string stops the client and browsers, but I think it needs more,
    // It does not generate a service unavailable!
#ifdef WIN32
		send(socknum,"HTTP/1.1 503 Unavailable\r\n\r\n:Err: Server Busy \r",47,0);
		closesocket(socknum);
#else
		write(socknum,"HTTP/1.1 503 Unavailable\r\n\r\n:Err: Server Busy \r",47);
		close(socknum);
#endif
		return;
	}

	sprintf(logt,"New connection from %s",inet_ntoa(name.sin_addr));
	st->Log("uSQLst",logt,0);
	if(!(nl=(struct clientLL*)malloc(sizeof(struct clientLL))))goto fail;
	if(!(nl->curr=uSQLctInit(st->db,++st->uniqueCnt,socknum,st->sec,netsec,st->maxbuffer,st->MaxRetRec,st->MaxQlength,st->MaxRepRecs)))goto fail;
	sprintf(nl->curr->RemIp,"%s",inet_ntoa(name.sin_addr));

	// Don't fail after added to Clients, or modify fail routine.
	nl->prev=NULL;
	if(st->Clients){
		nl->next=st->Clients;
		st->Clients->prev=nl;
		st->Clients=nl;
	}
	else{
		st->Clients=nl;
		st->Clients->next=NULL;
	}

    return;

fail:
    // MakeNewClient will always have been called with an open socket,
    // which must be closed if no new client is made.
#ifdef WIN32
   closesocket(socknum);
#else
    close(socknum);
#endif
   if(nl){
        if(nl->curr)uSQLctDestroy(nl->curr);
        free(nl);
   }

}


uSQLst *uSQLstInit(pLog log,char *db,char *secdb,int portnum,int maxclients,int maxbuffer,int MaxRetRec,int MaxQlength,int MaxRepRecs){
uSQLst *nst;
struct sockaddr_in name;
int flgs;
struct linger lg;
socklen_t lgs;
unsigned long nonblock=1;
int foo;

    nst=(uSQLst*)malloc(sizeof(uSQLst));
    if(!nst)return NULL;
    nst->uniqueCnt=0;
    nst->Log=log;
    nst->servsock=0;
    nst->sec=NULL;
    nst->Clients=NULL;
    nst->db=NULL;
    nst->maxclients=maxclients;
    nst->maxbuffer=maxbuffer;
    nst->MaxRetRec=MaxRetRec,
    nst->MaxQlength=MaxQlength;
    nst->MaxRepRecs=MaxRepRecs;


    // open db's
    if((nst->sec=uSQLsecOpen(secdb))==NULL)goto fail;
    nst->dbname=db;
    if(sqlite3_open(nst->dbname,&nst->db)){
    	nst->Log("uSQLst","Open db failed",0);
    	goto fail;
    }
    else nst->Log("uSQLst","db opened",0);


    // set up server socket
    if((nst->servsock=socket(PF_INET, SOCK_STREAM, 0))<1){
        nst->Log("uSQLst","Failed to open server socket",0);
        goto fail;
    }
    name.sin_family = AF_INET;
    name.sin_port = htons (portnum);
    name.sin_addr.s_addr = htonl (INADDR_ANY);
    if ((foo=bind (nst->servsock, (struct sockaddr *) &name, sizeof (name))) < 0){
    	nst->Log("uSQLst","Could not bind socket",0);
    	goto fail;
    }


    lg.l_onoff=1;
    lg.l_linger=20;
    lgs=sizeof(lg);

#ifdef WIN32
    // set socket non-blocking
    ioctlsocket(nst->servsock,FIONBIO,&nonblock);
    // set linger
    setsockopt(nst->servsock,SOL_SOCKET,SO_LINGER,(const char *)&lg,lgs);
#else
    // Set socket non-blocking
    flgs=fcntl(nst->servsock,F_GETFL,0);
    if(flgs==-1)goto fail;
    flgs|=O_NONBLOCK;
    fcntl(nst->servsock,F_SETFL,flgs);
    // set linger
    setsockopt(nst->servsock,SOL_SOCKET,SO_LINGER,&lg,lgs);
#endif

    if(listen(nst->servsock,nst->maxclients)<0)goto fail;

    return nst;

fail:
    uSQLstDestroy(nst);
    return NULL;
}

void uSQLstDestroy(uSQLst *st){
	if(st->sec)uSQLsecDestroy(st->sec);
	if(st->db)sqlite3_close(st->db);
#ifdef WIN32
	if(st->servsock>0)closesocket(st->servsock);
#else
	if(st->servsock>0)close(st->servsock);
#endif
    while(st->Clients)RemoveClient(st,st->Clients->curr);
    free(st);
}


int uSQLstPoll(uSQLst *st,int SliceMs){
fd_set sets;
fd_set setr;
struct timeval timeout;
struct clientLL *ll22,*ll33;
char msgbuff[50];
struct sockaddr_in name;
int addsize=sizeof(struct sockaddr_in);
int snum,stat;


    // Temporary polling routine
    // This should use a select to see the status of the client socks.
    // Truth is, works well as it is so I am reluctant to break it!

   	if((snum=accept(st->servsock,(struct sockaddr*)&name,&addsize))>0)
        MakeNewClient(st,snum);

    ll22=st->Clients;
    for(;ll22;){
    	if(SliceMs==0){
            stat=uSQLctVer(ll22->curr);
            if(stat<0){
                sprintf(msgbuff,"Removing dead client from %s",ll22->curr->RemIp);
                st->Log("uSQLst",msgbuff,0);
                ll33=ll22->next;
                RemoveClient(st,ll22->curr);
                ll22=ll33;
            }
            else{
            	ll22=ll22->next;
            }
    	}else{
            uSQLctPoll(ll22->curr);
            ll22=ll22->next;
    	}
    }


}



